package com.bluefairygames.java.libgdx.gameframework.events;

import com.bluefairygames.java.libgdx.gameframework.system.EventManager;

/**
 * Interface available for any game element that needs to receive events.
 * <p>
 * Classes implementing this interface must register for the desired events via the
 * {@link EventManager}.
 * 
 * @author Matt Parish
 */
public interface EventListener {

	/**
	 * Callback method invoked by the {@link EventManager} when a desired event has been dispatched.
	 * 
	 * @param event The dispatched {@link Event} object.
	 */
	public void onEvent(Event event);
}
