package com.bluefairygames.java.libgdx.gameframework.events.screen;

import com.badlogic.gdx.Gdx;
import com.bluefairygames.java.libgdx.gameframework.enums.ScreenEnum;
import com.bluefairygames.java.libgdx.gameframework.events.Event;

/**
 * Dispatched whenever a screen transition is required. Carries the next screen that
 * should be displayed.
 * @author Matt Parish
 */
public class ScreenTransition extends Event {
	private static final String TAG = ScreenTransition.class.getSimpleName();

	private ScreenEnum mNextScreen;
	
	/**
	 * @param nextScreen The next screen that should be displayed.
	 */
	public ScreenTransition(ScreenEnum nextScreen) {
		
		Gdx.app.log(TAG, "Transition to " + nextScreen.name() + " created.");
		
		mNextScreen = nextScreen;
	}
	
	/**
	 * @return The next screen that should be displayed.
	 */
	public ScreenEnum getNextScreen() {
		
		return mNextScreen;
	}
}
