package com.bluefairygames.java.libgdx.gameframework.system;

import java.util.Collection;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Random;

import com.bluefairygames.java.libgdx.gameframework.enums.ObjectEnum;
import com.bluefairygames.java.libgdx.gameframework.object.GameObject;
import com.bluefairygames.java.libgdx.gameframework.utils.Constants;

/**
 * 
 * @author Matt Parish
 */
public class Blackboard {
	private static final String TAG = Blackboard.class.getSimpleName();

    private static Blackboard sInstance;
    
    private Random mRandom;
    private int mNextId;
    
    //private Map<Variable,Object> _variableMap;
    
    private Map<String,GameObject> mObjectMap;
	private List<GameObject>      mObjects;	
	
	//private List<PhysicsObject>   _staticObjects;
	//private List<PhysicsObject>   _dynamicObjects;
	//private List<PhysicsObject>   _sensorObjects;
	
	//private List<PhysicsObject>   _projectiles;
			
	private Blackboard() { 
		
		mRandom = new Random(System.currentTimeMillis());
		mNextId = 0;
		
		//_variableMap = new HashMap<Variable,Object>();
		
		mObjectMap = new HashMap<String,GameObject>();
		mObjects = new LinkedList<GameObject>();
		
		/*_staticObjects = new ArrayList<PhysicsObject>();
		_dynamicObjects = new ArrayList<PhysicsObject>();
		_sensorObjects = new ArrayList<PhysicsObject>();
		
		_projectiles = new LinkedList<PhysicsObject>();
		
		_variableMap.put(Variable.maxAnglularAcceleration, 2.0f);*/
	}
	
	public static Blackboard get() {
		
		if (sInstance == null) { 
			
			sInstance = new Blackboard();
		}
		return sInstance;
	}
	
	public Random getRandom() { 
		
		return mRandom;
	}
	
	public int getNextId() { 
		
		return mNextId++;
	}
	
	/**
	 * Get one of the variables that don't change after 
	 * initialization.
	 * @param name
	 * @return
	 *//*
	public Object getVariableObject(Variable name) {
		return _variableMap.get(name);
	}*/
	
	/*public void setVariableObject(Variable name, Object value) { 
		_variableMap.remove(name);
		_variableMap.put(name, value);
	}*/
	
	public void add(GameObject object) {
		
		mObjects.add(object);
		mObjectMap.put(object.getName(), object);
	}
	
	public GameObject getObject(String name) { 
		
		return mObjectMap.get(name);
	}
	
	public GameObject getObject(ObjectEnum object) {
		
		switch(object) {
		
		case PLAYER: return mObjectMap.get(Constants.OBJECT_NAME_PLAYER);
		default: return null;
		}
	}
	
/*	public void addPhysicsObject(PhysicsObject obj) { 
		add(obj);
		if (obj.getType() == ObjectType.dynamic)
			_dynamicObjects.add(obj);
		else if (obj.getType() == ObjectType.obstacle)
			_staticObjects.add(obj);
		else if (obj.getType() == ObjectType.sensor)
			_sensorObjects.add(obj);
	}*/
	
	public Collection<GameObject> getAll() { 
		
		return mObjects;
	}
	
/*	public List<PhysicsObject> getStaticObjects() { 
		return _staticObjects;
	}
	
	public void addProjectile(PhysicsObject obj) { 
		_projectiles.add(obj);
	}
	
	public void removeProjectile(PhysicsObject obj) { 
		_projectiles.remove(obj);
	}
	
	public Collection<PhysicsObject> getProjectiles() { 
		return _projectiles;
	}*/
}
