package com.bluefairygames.java.libgdx.gameframework.system;

import com.badlogic.gdx.graphics.Camera;

public interface Subsystem {

	/**
	 * <b>public void update(float elapsedTime)</b><br>
	 * Update the system.
	 * @param elapsedTime The elapsed time since the previous update.
	 */
	public void update(float elapsedTime);
	
	/**
	 * <b>public void render(Camera camera)</b><br>
	 * Render the necessary visual system elements.
	 * @param camera The camera to which the visual elements should be rendered.
	 */
	public void render(Camera camera);
	
	/**
	 * <b>public void finish()</b><br>
	 * Perform any necessary cleanup of the system.
	 */
	public void finish();
}
